﻿init python:
    class phone_contact:
        def __init__(self, id, name = None, number = None, img = None, sms = []):
            self.id = id
            self.name = name
            self.number = number
            self.img = img
            self.sms = sms

    class phone_class:
        def __init__(self, owner, id, img = None):
            self.owner = owner
            self.id = id
            self.img = img
            self.active = None
            self.open = None
            self.stat = "Closed"
            self.contacts = []
            self.typing = ""
            self.current = None
            self.times = None
            self.phase = 0
            self.showing = None
        def show(self, screen, sender = None):
            self.showing = screen
            if screen == "sms list":
                renpy.show_screen("phone_sms_list", self)
            if screen == "sms":
                for i in self.contacts:
                    if i.id == sender:
                        self.active = i
                renpy.show_screen("phone_sms", self)



        def sms(self, sender, message, times):
            # if self.showing == "sms" and not sender in [self.active.id, self.id]:
            #     times = [0]
            #     renpy.play("phone/sms.ogg", "sound")
            self.current = [sender, message]
            if times:
                self.times = times
            else:
                self.times = [500, len(message)*40, 500]
            self.phase = 0
            renpy.pause(hard=True)


        def add(self, id, name = None, number = None, img = None):
            for i in self.contacts:
                if i.id == id:
                    if name:
                        i.name = name
                    if number:
                        i.number = number
                    if img:
                        i.img = img
            else:
                self.contacts.append(phone_contact(id, name, number, img))

        def tick(self):
            if self.times and len(self.times):
                if self.current[0] == self.id:
                    if self.phase == 0:
                        if self.times[0] <= 0:
                            self.times.pop(0)
                            self.phase = 2
                        else:
                            self.times[0] -= 100
                    else:
                        if len(self.current[1]) == len(self.typing):
                            self.times.pop(0)
                            self.phase = 0
                            self.typing = ""
                        else:
                            self.typing += self.current[1][len(self.typing)]
                else:
                    if self.phase == 0:
                        if self.times[0] <= 0:
                            self.times.pop(0)
                            self.phase = 1
                        else:
                            self.times[0] -= 100
                    else:
                        if self.times[0] <= 0:
                            self.times.pop(0)
                            self.phase = 0
                        else:
                            self.times[0] -= 100

            elif self.current:
                for i in self.contacts:
                    if i.id == self.current[0]:
                        self.open = i
                        break
                else:
                    self.contacts.append(phone_contact(self.current[0]))
                    self.open = self.contacts[-1]

                self.open.sms.append(self.current)
                if self.showing == "sms":
                    renpy.hide_screen("phone_sms")
                    renpy.show_screen("phone_sms", self)
                else:
                    renpy.play("phone/sms.ogg", "sound")

                self.current = None
                return 1
